//
//  DynamicalSystem.m
//  Rossler3D
//
//  Created by 川上 博 on 07/10/27.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//
#import "DynamicalSystem.h"

//double ra=0.35, rb=0.4, rc=4.5;
double ra=0.45, rb=0.4, rc=4.5;

void func(double x[], double f[], double t)
{
	f[0] = -x[1]-x[2];
	f[1] = x[0]+ra*x[1];
	f[2] = rb*x[0]+x[2]*(x[0]-rc);
}

void runge(int n, double h, double x[], double t)
{
	double k1[n],k2[n],k3[n],k4[n],xtemp[n];
	int i;

	func(x,k1,t);
	for (i=0; i<n; i++) xtemp[i]=x[i]+k1[i]/2.0*h;
	t+=h/2.0;
	func(xtemp,k2,t);
	for (i=0; i<n; i++) xtemp[i]=x[i]+k2[i]/2.0*h;
	func(xtemp,k3,t);
	for (i=0; i<n; i++) xtemp[i]=x[i]+k3[i]*h;
	t+=h/2.0;
	func(xtemp,k4,t);
	for (i=0; i<n; i++) x[i]+=(k1[i]+2.0*(k2[i]+k3[i])+k4[i])/6.0*h;
}

@implementation DynamicalSystem
@end
