#import "MyView.h"
#import "DynamicalSystem.h"
#include <math.h>

double L=10.0, tau=10.0, ze=10.0, alpha=M_PI/6.0, sigma=0.0;
double factor[2];
double xm[2]={-10.0, 10.0}, ym[2]={-10.0, 10.0};
double x[3]={0.0, 0.0, 2.0};

void runge(int n, double h, double x[], double t);

void pers(double x[], double g[])
{
	double den, h[2];
	
	den=L+tau+x[0]*sin(alpha)+x[1]*cos(alpha);
	h[0]=L*(x[0]*cos(alpha)-x[1]*sin(alpha)+sigma)/den;
	h[1]=L*(x[2]-ze)/den;
	g[0]=factor[0]*(h[0]-xm[0]);
	g[1]=factor[1]*(h[1]-ym[0]);
}

@implementation MyView
- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil) {
        repeatTimer = [NSTimer scheduledTimerWithTimeInterval:0.001
                            target:self
                            selector:@selector(drawByTimer:)
                            userInfo:nil
                            repeats:YES
            	      ];
	}
	return self;
}

- (BOOL)acceptsFirstResponder
{
	return YES;
}

- (void)drawRect:(NSRect)rect
{	
	double a[2], b[2], u[3]={0.0,0.0,0.0}, v[3];

	[[NSColor whiteColor] set];
	NSRectFill(rect);
	factor[0] = rect.size.width/(xm[1]-xm[0]);
	factor[1] = rect.size.height/(ym[1]-ym[0]);
	pers(u,a); 
	[[NSColor redColor] set];
	v[0]=5.0; v[1]=0.0; v[2]=0.0; pers(v,b);
	[NSBezierPath strokeLineFromPoint:NSMakePoint(a[0], a[1]) toPoint:NSMakePoint(b[0], b[1])];	
	[[NSColor greenColor] set];
	v[0]=0.0; v[1]=5.0; v[2]=0.0; pers(v,b);
	[NSBezierPath strokeLineFromPoint:NSMakePoint(a[0], a[1]) toPoint:NSMakePoint(b[0], b[1])];	
	[[NSColor blueColor] set];
	v[0]=0.0; v[1]=0.0; v[2]=10.0; pers(v,b);
	[NSBezierPath strokeLineFromPoint:NSMakePoint(a[0], a[1]) toPoint:NSMakePoint(b[0], b[1])];
}

- (void)drawByTimer:(id)timer
{
	double a[2];
	NSAffineTransform *transform=[NSAffineTransform transform];//4lines have to be added
	
    [self lockFocus];
	[[NSColor blueColor] set];
    oval = [NSBezierPath bezierPath];
	[transform translateXBy:0.5f yBy:0.5f];//4lines have to be added
	[oval transformUsingAffineTransform:transform];//4lines have to be added
	pers(x, a); 
	[oval moveToPoint:NSMakePoint(a[0],a[1])];
	runge(3, 0.05, x, 0.0);	
	pers(x, a); 
	[oval lineToPoint:NSMakePoint(a[0],a[1])];
    [oval stroke];
    [self unlockFocus];
    [[self window] flushWindow];
}

- (void)keyDown:(NSEvent *)theEvent
{
	NSString *keyChar=[theEvent charactersIgnoringModifiers];
	if ([keyChar isEqualToString:@"e"]){
		[self setNeedsDisplay:YES];
	}
	if ([keyChar isEqualToString:@"q"]) exit(0);
}
@end
